//
//  NzEvent.m
//  NzAnalyticsDemo
//
//  Created by FY on 2018/10/30.
//  Copyright © 2018 FY. All rights reserved.
//

#import "NzEvent.h"

@interface NzEvent ()
@property(nonatomic, strong) NSMutableDictionary * props; // 动态属性
@property(nonatomic, strong) NSMutableArray<NzEvent *> * items; // sub events
@end

@implementation NzEvent

- (void) setPropValue:(NSObject *)obj forKey:(NSString *)key
{
    if (obj == nil || key == nil) {
        return;
    }
    if (self.props == nil) {
        self.props = [NSMutableDictionary dictionary];
    }
    [self.props setValue:obj forKey:key];
}

- (NSObject *) propValueForKey:(NSString *)key
{
    return [self.props valueForKey:key];
}

- (void) addSubevent:(NzEvent *)event
{
    if (event == nil) {
        return;
    }
    if (self.items == nil) {
        self.items = [NSMutableArray array];
    }
    [self.items addObject:event];
}

- (instancetype)initWithDictionary:(NSDictionary *)dict
{
    if (self = [super initWithDictionary:dict]) {
        if(dict) {
//            [[self properties] enumerateObjectsUsingBlock:^(id  _Nonnull obj, NSUInteger idx, BOOL * _Nonnull stop) {
//                NSString * propertyName = (NSString *)obj;
//                [self setValue:[dict valueForKey:propertyName] forKey:propertyName];
//            }];
            NSArray * subevents = [dict objectForKey:@"items"];
            if (subevents != nil) {
                for (int i = 0; i < [subevents count]; i++) {
                    [self addSubevent:[[NzEvent alloc] initWithDictionary:[subevents objectAtIndex:i]]];
                }
            }
        }
    }
    return self;
}

- (NSMutableDictionary *)toDictionary
{
    NSMutableDictionary * dict = [super toDictionary];
    if (self.items != nil && [self.items count] > 0) {
        NSMutableArray * subevents = [NSMutableArray arrayWithCapacity:[self.items count]];
        for (int i = 0; i < [self.items count]; i++) {
            [subevents addObject:[[self.items objectAtIndex:i] toDictionary]];
        }
        [dict setValue:subevents forKey:@"items"];
    }
    return dict;
}

- (NSArray<NSString *> *)properties
{
    return @[@"event",@"eventDate", @"props"];
}

@end
