//
//  NzAnalyticsNetwork.m
//  NzAnalyticsDemo
//
//  Created by FY on 2022/5/13.
//  Copyright © 2022 FY. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "NzAnalyticsNetwork.h"

static NzAnalyticsNetwork * sharedInstance;

@interface NzAnalyticsNetwork ()

@property(nonatomic, strong) NzReachability * reachability;

@end

@implementation NzAnalyticsNetwork

+ (instancetype)shared
{
    if (sharedInstance == nil) {
        sharedInstance = [[NzAnalyticsNetwork alloc] init];
    }
    return sharedInstance;
}

- (instancetype)init
{
    if (self = [super init]) {
        self.reachability = [NzReachability reachabilityForInternetConnection];
        [self.reachability startNotifier];
    }
    return self;
}

- (NzNetworkStatus)getNetworkStatus
{
    return [self.reachability currentReachabilityStatus];
}

@end
