//
//  NzAnalyticsSDK.m
//  NzAnalytics
//
//  Created by FY on 2018/10/16.
//  Copyright © 2018 FY. All rights reserved.
//

#import "NzAnalyticsSDK.h"
#import "NzAnalyticsDummyAPI.h"
#import "NzAnalyticsRealAPI.h"
#import "NzUtils.h"
#import "NzAutoTrackAPI.h"

NSString * const kFileStorageContext = @"io.naza.analytics.storage.autotrack.context";

static id<NzAnalyticsAPI> sharedInstance = nil;
static id<NzAnalyticsAPI> dummyInstance = nil;

@implementation NzAnalyticsSDK

+ (void)setupWithConfiguration: (NzAnalyticsOption *)configuration
{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        if (sharedInstance == nil) {
            NzLog(@"setup nz analytics SDK configuration: writeKey [%@] endponit [%@]", configuration.writeKey, configuration.endpoint);
            sharedInstance = [[NzAnalyticsRealAPI alloc] initWithOption:configuration];
            [[NzAutoTrackAPI shared] setSdkOption:configuration];
        } else {
            NzLog(@"nz analytics SDK has been setup, cannot do it again!!!");
        }
    });
}

+ (id<NzAnalyticsAPI>)shared
{
    if (sharedInstance != nil) {
        return sharedInstance;
    } else {
        if (dummyInstance == nil) {
            dummyInstance = [[NzAnalyticsDummyAPI alloc] init];
        }
        return dummyInstance;
    }
}
@end
